#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Inspire by Conbagui tutorial found here:https://www.deviantart.com/conbagui/art/Create-a-Beautiful-Picture-frame-with-gimp-2-10-804032713
# author: Pocholo
# date: 4/18/21

# Comments directed to http://gimpchat.com

# Installation:
# This script should be placed in the user plugin folder

# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.

#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>.

from gimpfu import *
import gettext
import os, sys,time 

gettext.install("gimp20", gimp.locale_directory, unicode=True)

def pm_create_mothers_day_hearts_frame(customtext, fontname, textsize):
		
    #Initiates the temporary state
    pdb.gimp_context_set_defaults()
    pdb.gimp_context_set_default_colors()	
	   
    #Variables
    imgsize = 1400
    
    #Create background
    img = pdb.gimp_image_new(imgsize, imgsize, RGB)
    backLayer = pdb.gimp_layer_new(img, imgsize, imgsize, RGB_IMAGE, "Backkgroud", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(backLayer)
    pdb.gimp_image_add_layer(img, backLayer, 0)
    pdb.gimp_context_set_foreground((215, 82, 125))
    pdb.gimp_drawable_fill(backLayer, FILL_FOREGROUND)
    pdb.gimp_context_set_pattern("Small Hearts pattern #2.png")
    pdb.gimp_bucket_fill(backLayer, BUCKET_FILL_PATTERN, LAYER_MODE_NORMAL, 100, 255,  FALSE, 700, 700)
         
    #Display process 
    pdb.gimp_display_new(img)
    
    #Create paper heart 1
    paper1Layer = pdb.gimp_layer_new(img, imgsize, imgsize, RGB_IMAGE, "Paper heart #1", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(paper1Layer)
    pdb.gimp_image_add_layer(img, paper1Layer, 0)
    pdb.gimp_context_set_foreground((232, 105, 147))
    pdb.gimp_drawable_fill(paper1Layer, FILL_FOREGROUND)
    pdb.gimp_context_set_brush("Heart vector")
    pdb.gimp_context_set_brush_size(950)
    pdb.gimp_context_set_brush_aspect_ratio(0)
    pdb.gimp_context_set_brush_angle(0)
    pdb.gimp_context_set_brush_spacing(0.1)
    pdb.gimp_context_set_dynamics("Dynamics Off")  
    pdb.gimp_eraser_default(paper1Layer, 2, [700, 700])
    pdb.gimp_context_set_brush("Heart vector")
    pdb.gimp_context_set_brush_size(425)
    pdb.gimp_eraser_default(paper1Layer, 2, [210, 1125])
    pdb.gimp_context_set_brush("Heart vector")
    pdb.gimp_context_set_brush_size(180)
    pdb.gimp_eraser_default(paper1Layer, 2, [420, 1222])
    pdb.gimp_image_select_item(img, 2, paper1Layer)
    channel = pdb.gimp_selection_save(img)
    pdb.gimp_selection_none(img)
    pdb.gimp_item_set_visible(channel, TRUE)
    channel = pdb.gimp_item_transform_flip_simple(channel, ORIENTATION_HORIZONTAL, TRUE, 0)
    pdb.gimp_image_select_item(img, 2, channel)
    pdb.gimp_selection_invert(img)
    pdb.gimp_edit_clear(paper1Layer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_remove_channel(img, channel)
	
	#Paper one drop shadow
    shadow1Layer = pdb.gimp_layer_new(img, imgsize, imgsize, RGB_IMAGE, "Paper heart #1-dropshadow", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(shadow1Layer)
    pdb.gimp_image_add_layer(img, shadow1Layer, 1)
    pdb.gimp_context_set_foreground((0, 0, 0))
    pdb.gimp_drawable_fill(shadow1Layer, FILL_FOREGROUND)
    pdb.gimp_image_select_item(img, 2, paper1Layer)
    pdb.gimp_selection_invert(img)
    pdb.gimp_edit_clear(shadow1Layer)
    pdb.gimp_selection_none(img)
    pdb.plug_in_gauss_iir2(img, shadow1Layer, 25, 25)
    pdb.plug_in_gmic_qt(img, shadow1Layer, 1, 0, "-v - -fx_gaussian_blur 7,0,0,1,0,0,0")
    
    #Hearts one soft and sharp edges
    pdb.python_layerfx_stroke(img, paper1Layer, 
                               (255, 255, 255),    #color
                                           100,    #opacity
                                             0,    #mode - LAYER_MODE_NORMAL_LEGACY
                                             2,    #size
                                           100,    #position
                                          TRUE)    #merge
    paper1Layer = pdb.gimp_image_get_layer_by_name(img, "Paper heart #1")
    pdb.plug_in_gauss(img, paper1Layer, 10, 10, 0)  
    pdb.plug_in_unsharp_mask(img, paper1Layer, 1.5, 5, 0)
    
    #Create paper heart two
    paper2Layer = pdb.gimp_layer_new(img, imgsize, imgsize, RGB_IMAGE, "Paper heart #2", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(paper2Layer)
    pdb.gimp_image_add_layer(img, paper2Layer, 0)
    pdb.gimp_context_set_foreground((232, 132, 162))
    pdb.gimp_drawable_fill(paper2Layer, FILL_FOREGROUND)
    pdb.gimp_context_set_brush("Heart vector")
    pdb.gimp_context_set_brush_size(1100)
    pdb.gimp_context_set_brush_aspect_ratio(0)
    pdb.gimp_context_set_brush_angle(0)
    pdb.gimp_context_set_brush_spacing(0.1)
    pdb.gimp_context_set_dynamics("Dynamics Off")  
    pdb.gimp_eraser_default(paper2Layer, 2, [700, 700])
      
    #Paper two drop shadow
    shadow2Layer = pdb.gimp_layer_new(img, imgsize, imgsize, RGB_IMAGE, "Paper heart #2-dropshadow", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(shadow2Layer)
    pdb.gimp_image_add_layer(img, shadow2Layer, 1)
    pdb.gimp_context_set_foreground((0, 0, 0))
    pdb.gimp_drawable_fill(shadow2Layer, FILL_FOREGROUND)
    pdb.gimp_eraser_default(shadow2Layer, 2, [700, 700])
    pdb.plug_in_gmic_qt(img, shadow2Layer, 1, 0, "-v - -fx_gaussian_blur 7,0,0,1,0,0,0")
   
    #Hearts two soft and sharp edges
    pdb.python_layerfx_stroke(img, paper2Layer, 
                               (255, 255, 255),    #color
                                           100,    #opacity
                                             0,    #mode - LAYER_MODE_NORMAL_LEGACY
                                             2,    #size
                                           100,    #position
                                          TRUE)    #merge
    paper2Layer = pdb.gimp_image_get_layer_by_name(img, "Paper heart #2")
    pdb.plug_in_gauss(img, paper2Layer, 10, 10, 0)  
    pdb.plug_in_unsharp_mask(img, paper2Layer, 1.5, 5, 0)
    pdb.gimp_image_select_item(img, 2, paper1Layer)
    pdb.gimp_selection_invert(img) 
    pdb.gimp_edit_clear(shadow2Layer)
    pdb.gimp_edit_clear(paper2Layer)
    pdb.gimp_selection_none(img)
    
    #Create paper heart three
    paper3Layer = pdb.gimp_layer_new(img, imgsize, imgsize, RGB_IMAGE, "Paper heart #3", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(paper3Layer)
    pdb.gimp_image_add_layer(img, paper3Layer, 0)
    pdb.gimp_context_set_foreground((240, 168, 188))
    pdb.gimp_drawable_fill(paper3Layer, FILL_FOREGROUND)
    pdb.gimp_context_set_brush("Heart vector")
    pdb.gimp_context_set_brush_size(1240)
    pdb.gimp_context_set_brush_aspect_ratio(0)
    pdb.gimp_context_set_brush_angle(0)
    pdb.gimp_context_set_brush_spacing(0.1)
    pdb.gimp_context_set_dynamics("Dynamics Off")  
    pdb.gimp_eraser_default(paper3Layer, 2, [700, 700])
      
    #Paper three drop shadow
    shadow3Layer = pdb.gimp_layer_new(img, imgsize, imgsize, RGB_IMAGE, "Paper heart #3-dropshadow", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(shadow3Layer)
    pdb.gimp_image_add_layer(img, shadow3Layer, 1)
    pdb.gimp_context_set_foreground((0, 0, 0))
    pdb.gimp_drawable_fill(shadow3Layer, FILL_FOREGROUND)
    pdb.gimp_eraser_default(shadow3Layer, 2, [700, 700])
    pdb.plug_in_gmic_qt(img, shadow3Layer, 1, 0, "-v - -fx_gaussian_blur 7,0,0,1,0,0,0")
    
    #Hearts three soft and sharp edges
    pdb.python_layerfx_stroke(img, paper3Layer, 
                               (255, 255, 255),    #color
                                           100,    #opacity
                                             0,    #mode - LAYER_MODE_NORMAL_LEGACY
                                             2,    #size
                                           100,    #position
                                          TRUE)    #merge
    paper3Layer = pdb.gimp_image_get_layer_by_name(img, "Paper heart #3")
    pdb.plug_in_gauss(img, paper3Layer, 10, 10, 0)  
    pdb.plug_in_unsharp_mask(img, paper3Layer, 1.5, 5, 0)
    pdb.gimp_image_select_item(img, 2, paper1Layer)
    pdb.gimp_selection_invert(img) 
    pdb.gimp_edit_clear(shadow3Layer)
    pdb.gimp_edit_clear(paper3Layer)
    pdb.gimp_selection_none(img)
    
	#Create paper heart four
    paper4Layer = pdb.gimp_layer_new(img, imgsize, imgsize, RGB_IMAGE, "Paper heart #4", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(paper4Layer)
    pdb.gimp_image_add_layer(img, paper4Layer, 0)
    pdb.gimp_context_set_foreground((248, 196, 212))
    pdb.gimp_drawable_fill(paper4Layer, FILL_FOREGROUND)
    pdb.gimp_context_set_brush("Heart vector")
    pdb.gimp_context_set_brush_size(1375)
    pdb.gimp_context_set_brush_aspect_ratio(0)
    pdb.gimp_context_set_brush_angle(0)
    pdb.gimp_context_set_brush_spacing(0.1)
    pdb.gimp_context_set_dynamics("Dynamics Off")  
    pdb.gimp_eraser_default(paper4Layer, 2, [700, 700])
      
    #Paper drop shadow four
    shadow4Layer = pdb.gimp_layer_new(img, imgsize, imgsize, RGB_IMAGE, "Paper heart #3-dropshadow", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(shadow4Layer)
    pdb.gimp_image_add_layer(img, shadow4Layer, 1)
    pdb.gimp_context_set_foreground((0, 0, 0))
    pdb.gimp_drawable_fill(shadow4Layer, FILL_FOREGROUND)
    pdb.gimp_eraser_default(shadow4Layer, 2, [700, 700])
    pdb.plug_in_gmic_qt(img, shadow4Layer, 1, 0, "-v - -fx_gaussian_blur 7,0,0,1,0,0,0")
    
    #Hearts four soft and sharp edges
    pdb.python_layerfx_stroke(img, paper4Layer, 
                               (255, 255, 255),    #color
                                           100,    #opacity
                                             0,    #mode - LAYER_MODE_NORMAL_LEGACY
                                             2,    #size
                                           100,    #position
                                          TRUE)    #merge
    paper4Layer = pdb.gimp_image_get_layer_by_name(img, "Paper heart #4")
    pdb.plug_in_gauss(img, paper4Layer, 10, 10, 0)  
    pdb.plug_in_unsharp_mask(img, paper4Layer, 1.5, 5, 0)
    pdb.gimp_image_select_item(img, 2, paper1Layer)
    pdb.gimp_selection_invert(img) 
    pdb.gimp_edit_clear(shadow4Layer)
    pdb.gimp_edit_clear(paper4Layer)
    pdb.gimp_selection_none(img)
    
    #paper angels left side
    angel1Layer = pdb.gimp_layer_new(img, imgsize, imgsize, RGBA_IMAGE, "Angels", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, angel1Layer, 0)
    pdb.gimp_layer_add_alpha(angel1Layer)
    pdb.gimp_drawable_fill(angel1Layer, FILL_TRANSPARENT)
    pdb.gimp_context_set_foreground((248, 196, 212))
    pdb.gimp_context_set_brush("Angel")
    pdb.gimp_context_set_brush_size(500)
    pdb.gimp_context_set_brush_aspect_ratio(0)
    pdb.gimp_context_set_brush_angle(12.50)
    pdb.gimp_context_set_brush_spacing(0.1)
    pdb.gimp_context_set_dynamics("Dynamics Off")  
    pdb.gimp_paintbrush_default(angel1Layer, 2, [315, 455])
    
    #paper angels right side
    non_empty = pdb.gimp_edit_copy(angel1Layer)
    angel2Layer = pdb.gimp_layer_new(img, imgsize, imgsize, RGBA_IMAGE, "Angel2", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, angel2Layer, 0)
    pdb.gimp_layer_add_alpha(angel2Layer)
    pdb.gimp_drawable_fill(angel2Layer, FILL_TRANSPARENT)
    angel2Layer = pdb.gimp_edit_paste(angel2Layer, FALSE)
    pdb.gimp_floating_sel_anchor(angel2Layer) 
    angel2Layer = pdb.gimp_image_get_layer_by_name(img, "Angel2")
    angel2Layer = pdb.gimp_item_transform_flip_simple(angel2Layer, ORIENTATION_HORIZONTAL, TRUE, 0) 
    angel1Layer = pdb.gimp_image_merge_down(img, angel2Layer, CLIP_TO_IMAGE)
    
    #paper angels shadow
    non_empty = pdb.gimp_edit_copy(angel1Layer)
    angelshadow = pdb.gimp_layer_new(img, imgsize, imgsize, RGBA_IMAGE, "Angels shadow", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, angelshadow, 1)
    pdb.gimp_layer_add_alpha(angelshadow)
    pdb.gimp_drawable_fill(angelshadow, FILL_TRANSPARENT)
    angelshadow = pdb.gimp_edit_paste(angelshadow, FALSE)
    pdb.gimp_floating_sel_anchor(angelshadow) 
    angelshadow = pdb.gimp_image_get_layer_by_name(img, "Angels shadow")
    pdb.gimp_colorize(angelshadow, 0, 0, -100)
    pdb.plug_in_gmic_qt(img, angelshadow, 1, 0, "-v - -fx_gaussian_blur 2,0,0,1,0,0,0")
    pdb.gimp_image_set_active_layer(img, angel1Layer)
    
    #Create the top text		
    textW = textsize/0.5
    textH = textsize/2
    pdb.gimp_context_set_foreground((232, 105, 147))
    textLayer = pdb.gimp_text_fontname(img, None, 0, 0, customtext, 5, 1, textsize, PIXELS, fontname)
    pdb.gimp_text_layer_set_justification(textLayer, 2)
            
    #Resize text
    pdb.gimp_layer_scale (textLayer, textW, textH, TRUE)
        
    #Making the text centered	
    textLayer = pdb.gimp_image_get_active_layer(img)
    pdb.gimp_image_set_active_layer(img, textLayer)
    wh = pdb.gimp_drawable_width(textLayer)
    hh = pdb.gimp_drawable_height(textLayer)
    w = pdb.gimp_image_width(img)
    h = pdb.gimp_image_height(img)
    pdb.gimp_image_set_active_layer(img,textLayer)
    centerx=w/2
    centery=h/90
    adw=wh/2
    adh=hh/90
    sw=centerx - adw
    sh=centery - adh		
    pdb.gimp_layer_set_offsets(textLayer, sw, sh)
    pdb.gimp_layer_resize_to_image_size(textLayer)
    
    #Drop Shadow on the text
    pdb.python_layerfx_drop_shadow(img, textLayer,
										 ("Black"),   #color
											    45,   #opacity
												 0,   #contou - linear
												 0,   #noise
												 3,   #mode - multiply
												 7,   #spread
											 	 8,   #size
											   120,   #offset_angle
											     5,   #offset_distance
											  TRUE,   #knockout
											 FALSE)   #merge
    
   
    pdb.gimp_image_set_active_layer(img, backLayer)
	#Set gimp to default
    pdb.gimp_context_set_defaults()
    pdb.gimp_context_set_default_colors()
	
register(
    "pm_create_mothers_day_hearts_frame",
    "Creates a Mother's Day Heats Frame",
    "Creates a Mother's Day Heats Frame",
    "Pocholo",
    "Pocholo",
    "2021",
    "Create a Mother's Day Heart Frame",
    "",
    [
    (PF_STRING, "customtext", "Text string", "Happy Mother's Day"),
    (PF_FONT, "fontname", "Font name", "Femina"),
    (PF_SPINNER, "textsize", "Text size", 400, (100, 400, 1)),  
    
    ],
    [], 
    pm_create_mothers_day_hearts_frame, menu="<Image>/Pocholo-scripts/Create a Mother's Day Heart Frame",
    domain=("gimp20", gimp.locale_directory))
main()			   